import es,usermsg,cfglib,gamethread

import psyco
psyco.full()

info = es.AddonInfo()
info['name'] = "Advanced Wave Spawn"
info['basename'] = "spawnwave"
info['version'] = "1.0 Pub"
info['authors'] = "Shidobu"
info['url'] = "http://www.sddcommunity.com"
info['description'] = "Advanced set of tools for respawning."

config = cfglib.AddonCFG(es.getAddonPath("spawnwave") + "/spawnwave_config.cfg")
config.text("*****************************")
config.text("*****Advanced Wave Spawn*****")
config.text("***********||CFG||***********")
config.text("*****************************")
config.text(" ")
config.text(" ")
config.text("************************")
config.text("******||Settings||******")
config.text("************************")
ws_roundmsg = config.cvar("ws_roundmsg",1,"Enable/Disable telling every player at round start that wave spawn is enabled.")
ws_mapfilter = config.cvar("ws_mapfilter","<0>","Set what maps you do not want asp active on. format: <mapname> example: ws_mapfilter <aim_ag_texture2><de_dust2>")
ws_tell = config.cvar("ws_tell",1,"Enable/Disable telling the player that the player is going to respawn in a form of a count down.")
ws_time = config.cvar("ws_time",2,"How long you want the until the player respawns.")
ws_showplayers = config.cvar("ws_showplayers",1,"Enable/Disable showing the players how many players are alive on each team.")
ws_showplayers_hostname = config.cvar("ws_showplayers_hostname",1,"Enable/Disable Displaying alive players in your server name.")
ws_hostname = config.cvar("ws_hostname","[SDD] Script Testing -www.sddcommunity.com- ","Set the wanted name for your server.")
config.text(" ")
config.text(" ")
config.write()

es.set("ws_version",info.version,info.description)
es.makepublic("ws_version")

def load():
	global ws_check
	ws_check = 1

def unload():
	global ws_check
	ws_check = 0

def es_map_start(ev):
	global ws_map
	ws_map = "<%s>"%es.ServerVar("eventscripts_currentmap")
	if ws_map not in str(ws_mapfilter):
		if ws_showplayers == 1 and ws_check == 1:
			ShowPlayers()

def round_start(ev):
	if ws_map not in str(ws_mapfilter) and ws_check == 1:
		if ws_roundmsg == 1:
			es.msg("#multi","\x05[Wave Spawn] #greenAdvanced Wave Spawn #lightgreenby #greenShidobu #lightgreenis active on this server.")

def player_death(ev):
	if ws_map not in str(ws_mapfilter) and ws_check == 1:
		WaveSpawn(ev["userid"],ws_time)

def WaveSpawn(userid,time):
	if ws_map not in str(ws_mapfilter) and ws_check == 1:
		if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 1:
			time -= 1
			if ws_tell == 1: usermsg.hudhint(userid,"[Wave Spawn]\nYou will respawn in %s seconds."%time)
			if time > 0: gamethread.delayed(1,WaveSpawn,(userid,time))
			if time == 0:
				es.setplayerprop(userid,"CCSPlayer.m_iPlayerState",0)
				es.setplayerprop(userid,"CCSPlayer.baseclass.m_lifeState",512)
				es.spawnplayer(userid)

def ShowPlayers():
	if ws_map not in str(ws_mapfilter) and ws_check == 1:
		if ws_showplayers == 1:
			tt = es.getplayercount()
			if tt > 0:
				c = es.getlivingplayercount(3)
				t = es.getlivingplayercount(2)
				playerlist = es.getUseridList()
				for player in playerlist:
					es.centertell(player,"[Wave Spawn] CTs-%s|Ts-%s"%(c,t))
				if ws_showplayers_hostname == 1:
					es.ServerVar("hostname").set("%s CTs:%s|Ts:%s"%(ws_hostname,c,t))
			gamethread.delayed(1,ShowPlayers,())
	

